#include <cstring>
#include <cstdlib>
#include <vector>
#include <sstream>
#include <string>
#include <fstream>
using namespace std;

long double stof(const string& s)
{
  stringstream ss(s);
  long double res;
  ss >> res;
  return res;
}
ofstream score("score.log");
ofstream report("report.log");
void Score(const long double scr)
{
  score << scr;
  if (scr != .0)
    report << "Accepted!";
  report << endl
    << "************************************" << endl
    << " Checker by abcdabacd987";
  exit(0);
}
int main(int argc, char* argv[])
{
  ifstream std(argv[2]);
  ifstream fin("prog85.in");
  ifstream ans("prog85.out");
  long double fsco = stof(argv[1]);

  int stdHasSolution, ansHasSolution;
  std >> stdHasSolution;
  ans >> ansHasSolution;
  if (stdHasSolution != ansHasSolution)
  {
    report << "Wrong at Line 1:" << endl
      << "Standard Answer: " << stdHasSolution << endl
      << "  Your   Answer: " << ansHasSolution;
    Score(.0);
  }
  if (!stdHasSolution)
    Score(fsco);

  int n, m;
  fin >> n >> m;
  vector<int> company, table;
  for (int i = 0, x; i < n; ++i)
  {
    fin >> x;
    company.push_back(x);
  }
  for (int i = 0, x; i < m; ++i)
  {
    fin >> x;
    table.push_back(x);
  }

  string s;
  int lines = 0;
  for (getline(ans, s); getline(ans, s) && ans; ++lines)
  {
    vector<bool> set;
    set.resize(m);
    stringstream ss(s);
    int nums = 0;
    for (int x; ss >> x; ++nums)
    {
      if (x < 1 || x > m)
      {
        report << "Wrong at Line" << lines+2 << endl
          << x << " should be an integer in [1, " << m << "]";
        Score(.0);
      }
      if (set[x-1])
      {
        report << "Wrong at Line" << lines+2 << endl
          << x << " disappeared more than once!";
        Score(.0);
      }
      set[x-1] = true;
    }
    if (nums != company[lines])
    {
      report << "Wrong at Line" << lines+2 << endl
        << "There should be " << company[lines] << " number(s), " << endl
        << "but only " << nums << " disappeared";
      Score(.0);
    }
  }
  if (lines != n)
  {
    report << "Wrong at Line" << lines+2 << endl
      << "There should be " << n+1 << " lines, " << endl
      << "but only " << lines+1 << " disappeared";
    Score(.0);
  }
  Score(fsco);
}
