#include <cstdio>
#include <cstring>
#include <queue>
#include <algorithm>

const int MAXN = 1<<20, MAXM = 100;
struct Edge/*{{{*/
{
  int v, w;
  Edge *next;
} g[14195704], *header[MAXN];
void add_edge(const int x, const int y, const int w)
{
  static int LinkSize = 0;
  Edge* node = g+(LinkSize++);
  node->v = y;
  node->w = w;
  node->next = header[x];
  header[x] = node;
}/*}}}*/
int FULL, nodes, n, m;
char B[21], F[21];
void set0(int& x, const int k) { x &= ~(1 << k); }
void set1(int& x, const int k) { x |= 1 << k; }
int SPFA(const int source, const int target)/*{{{*/
{
  static int dist[MAXN];
  static bool set[MAXN];
  static std::queue<int> Q;
  memset(dist, 0x3F, sizeof(*dist)*nodes);
  dist[source] = 0, set[source] = true;
  Q.push(source);
  for (int u; !Q.empty(); Q.pop(), set[u] = false)
  {
    u = Q.front();
    for (Edge *e = header[u]; e; e = e->next)
      if (dist[u] + e->w < dist[e->v])
      {
        dist[e->v] = dist[u] + e->w;
        if (!set[e->v])
        {
          set[e->v] = true;
          Q.push(e->v);
        }
      }
  }
  return dist[target];
}/*}}}*/
int main()
{
  freopen("prog812.in", "r", stdin); 
  freopen("prog812.out", "w", stdout); 
  scanf("%d%d", &n, &m);
  nodes = 1<<n, FULL = nodes-1;
  for (int time; m--; )
  {
    scanf("%d %s %s", &time, B, F);
    int Bmask1 = 0, Bmask0 = FULL, Fmask1 = 0, Fmask0 = FULL;
    for (int i = 0; i < n; ++i)
      if (B[n-i-1] == '+') set1(Bmask1, i);
      else if (B[n-i-1] == '-') set0(Bmask0, i);
    for (int i = 0; i < n; ++i)
      if (F[n-i-1] == '+') set1(Fmask1, i);
      else if (F[n-i-1] == '-') set0(Fmask0, i);
    for (int i = 0; i < nodes; ++i)
    {
      if ((i & Bmask1) == Bmask1 && (i | Bmask0) == Bmask0)
      {
        const int v = (i & Fmask0) | Fmask1;
        if (v != i)
          add_edge(i, v, time);
      }
    }
  }
  int ans = SPFA(FULL, 0);
  printf("%d", ans == 0x3F3F3F3F ? 0 : ans);
  fclose(stdin);fclose(stdout); 
}
