#include <cstdio>
#include <cstring>
#include <bitset>
#include <queue>
#include <algorithm>

const int MAXN = 15, MAXP = 10;
const int D[][2] = {{1, 0}, {0, 1}, {-1, 0}, {0, -1}};
struct Info
{
  int x, y, key, step;
  Info(const int a, const int b, const int c, const int d): x(a), y(b), key(c), step(d) { }
};
bool test(const int x, const int k) { return x & (1 << k); }/*{{{*/
void set1(int& x, const int k) { x |= 1 << k; }/*}}}*/
int n, m, p, K, S, p2, key[MAXN][MAXN];
std::bitset<1<<MAXP> wall[MAXN][MAXN][MAXN][MAXN];
int BFS()/*{{{*/
{
  static std::bitset<1<<MAXP> inq[MAXN][MAXN];
  static std::queue<Info> Q;
  for (Q.push(Info(0, 0, 0, 0)), inq[0][0].set(0); !Q.empty(); Q.pop())
  {
    const int x = Q.front().x, y = Q.front().y, Key = Q.front().key, step = Q.front().step;
    for (int i = 0; i < 4; ++i)
    {
      const int xx = x+D[i][0];
      const int yy = y+D[i][1];
      if (xx < 0 || xx >= n || yy < 0 || yy >= m || wall[x][y][xx][yy][Key] || inq[xx][yy].test(Key))
        continue;
      if (xx == n-1 && yy == m-1)
        return step+1;
      Q.push(Info(xx, yy, Key | key[xx][yy], step+1));
      inq[xx][yy].set(Key | key[xx][yy]);
    }
  }
  return -1;
}/*}}}*/
int main()
{
  freopen("prog814.in", "r", stdin); 
  freopen("prog814.out", "w", stdout); 
  scanf("%d%d%d%d", &n, &m, &p, &K);
  p2 = 1<<p;
  for (int i = 0, x1, y1, x2, y2, type; i < K; ++i)
  {
    scanf("%d%d%d%d%d", &x1, &y1, &x2, &y2, &type);
    --x1, --y1, --x2, --y2;
    for (int j = 0; j < p2; ++j)
      if (type == 0 || !test(j, type-1))
      {
        wall[x1][y1][x2][y2].set(j);
        wall[x2][y2][x1][y1].set(j);
      }
  }
  scanf("%d", &S);
  for (int x, y, t, i = 0; i < S; ++i)
  {
    scanf("%d%d%d", &x, &y, &t);
    set1(key[x-1][y-1], t-1);
  }

  printf("%d", BFS());
  fclose(stdin);fclose(stdout); 
}
