#include <cstdio>
#include <cstring>
#include <queue>
#include <algorithm>

const int INF = 0x3F3F3F3F;
const int MAXN = 100*100, MAXK = 10;
const int VERTEXS = MAXN*MAXK+MAXN;
struct Edge/*{{{*/
{
  int v, w;
  Edge *next;
} g[MAXN*MAXK*5], *header[VERTEXS];
void AddEdge(const int x, const int y, const int w)
{
  static int LinkSize = 0;
  Edge* node = g+(LinkSize++);
  node->v = y;
  node->w = w;
  node->next = header[x];
  header[x] = node;
}/*}}}*/
int n, K, A, B, C;
inline int Point(const int gas, const int x, const int y) { return gas*n*n+x*n+y; }
int SPFA(const int source, const int K)/*{{{*/
{
  static int dist[VERTEXS];
  static bool set[VERTEXS];
  static std::queue<int> Q;
  memset(dist, 0x3F, sizeof(dist));
  dist[source] = 0, set[source] = true;
  Q.push(source);
  for (int u; !Q.empty(); Q.pop(), set[u] = false)
  {
    u = Q.front();
    for (Edge *e = header[u]; e; e = e->next)
      if (dist[u] + e->w < dist[e->v])
      {
        dist[e->v] = dist[u] + e->w;
        if (!set[e->v])
        {
          set[e->v] = true;
          Q.push(e->v);
        }
      }
  }
  int ans = INF;
  for (int k = 0; k <= K; ++k)
    ans = std::min(ans, dist[Point(k, n-1, n-1)]);
  return ans;
}/*}}}*/
int main()
{
  freopen("prog815.in", "r", stdin); 
  freopen("prog815.out", "w", stdout); 
  scanf("%d%d%d%d%d", &n, &K ,&A, &B, &C);
  for (int i = 0; i < n; ++i)
    for (int j = 0, x; j < n; ++j)
    {
      scanf("%d", &x);
      for (int k = 0, cost = A + (x == 1 ? 0 : C); k <= K; ++k)
      {
        if (k != K) AddEdge(Point(k, i, j), Point(K, i, j), cost);
        if (k == 0) continue;
        const int l = x == 1 ? K : k;
        if (i-1 >= 0) AddEdge(Point(l, i, j), Point(l-1, i-1, j), B);
        if (j-1 >= 0) AddEdge(Point(l, i, j), Point(l-1, i, j-1), B);
        if (i+1 < n) AddEdge(Point(l, i, j), Point(l-1, i+1, j), 0);
        if (j+1 < n) AddEdge(Point(l, i, j), Point(l-1, i, j+1), 0);
      }
    }
  printf("%d", SPFA(Point(K, 0, 0), K));
  fclose(stdin);fclose(stdout); 
}
