#include <queue>
#include <cstdio>
#include <cstring>
#include <iostream>

const int INF = 0x3F3F3F3F;
const int MAXN = 100;
const int VERTEXS = MAXN*2+2;
int n, m, avg, a[MAXN];
struct Edge/*{{{*/
{
  int v, f, c;
  Edge *next, *op;
} g[(MAXN+MAXN*4)*2], *header[VERTEXS];
int LinkSize = 0;
Edge* add_edge(const int x, const int y, const int f, const int c, Edge* const op = 0)
{
  Edge* node = g+(LinkSize++);
  node->v = y;
  node->f = f;
  node->c = c;
  node->op = op;
  node->next = header[x];
  if (op)
    op->op = node;
  return header[x] = node;
}
inline void AddEdge(const int x, const int y, const int f, const int c)
{ add_edge(y, x, 0, -c, add_edge(x, y, f, c)); }/*}}}*/
struct AugRoad/*{{{*/
{
  int pre;
  Edge* e;
  void operator()(const int p, Edge* const x) { pre = p, e = x; }
} augroad[VERTEXS];
int S, T;
bool SPFA()
{
  static int dist[VERTEXS];
  static bool set[VERTEXS];
  static std::queue<int> Q;
  memset(dist, 0x3F, sizeof(dist));
  dist[S] = 0, set[S] = true;
  Q.push(S);
  for (int u; !Q.empty(); Q.pop(), set[u] = false)
  {
    u = Q.front();
    for (Edge *e = header[u]; e; e = e->next)
      if (e->f > 0 && dist[u] + e->c < dist[e->v])
      {
        dist[e->v] = dist[u] + e->c;
        augroad[e->v](u, e);
        if (!set[e->v])
        {
          set[e->v] = true;
          Q.push(e->v);
        }
      }
  }
  return dist[T] != INF;
}
int Costflow()
{
  int cost = 0;
  while (SPFA())
  {
    int minflow = INF;
    for (int u = T; u != S; u = augroad[u].pre)
      minflow = std::min(minflow, augroad[u].e->f);
    for (int u = T; u != S; u = augroad[u].pre)
    {
      cost += minflow * augroad[u].e->c;
      augroad[u].e->f -= minflow;
      augroad[u].e->op->f += minflow;
    }
  }
  return cost;
}/*}}}*/
int main()
{
  freopen("prog819.in", "r", stdin); 
  freopen("prog819.out", "w", stdout); 
  scanf("%d", &n);
  S = n+n, T = S+1;
  for (int i = 0; i < n; ++i)
  {
    scanf("%d", a+i);
    avg += a[i];
  }
  avg /= n;
  for (int i = 0; i < n; ++i)
  {
    if (avg < a[i])
      AddEdge(S, i, a[i]-avg, 0);
    else if (avg > a[i])
      AddEdge(i+n, T, avg-a[i], 0);
    AddEdge(i, n+(i+1)%n, INF, 1);
    AddEdge(i, n+(n+i-1)%n, INF, 1);
    AddEdge(n+i, n+(i+1)%n, INF, 1);
    AddEdge(n+i, n+(n+i-1)%n, INF, 1);
  }
  printf("%d", Costflow());
  fclose(stdin);fclose(stdout); 
}
