#include <cstdio>
#include <string>
#include <vector>
#include <sstream>
#include <iterator>
#include <iostream>
#include <algorithm>

const int MAXN = 100, MAXM = 1000;
const int VERTEXS = MAXN+MAXM+2;
const int INF = 0x3F3F3F3F;
struct Edge
{
  int v, f;
  Edge *op, *next;
} g[(MAXN*MAXM+MAXN+MAXM)*2], *header[VERTEXS];
Edge* add_edge(const int x, const int y, const int w, Edge* const op = 0)
{
  static int LinkSize;
  Edge *node = g+(LinkSize++);
  node->v = y;
  node->f = w;
  node->op = op;
  node->next = header[x];
  if (op)
    op->op = node;
  return header[x] = node;
}
int n, m, profit[MAXN+1];
int nodes, S, T, dist[VERTEXS], dc[VERTEXS];
int SAP(const int u, const int delta)
{
  if (u == T)
    return delta;
  int sum = 0, mindist = nodes;
  for (Edge *e = header[u]; e; e = e->next)
  {
    if (dist[u]-1 == dist[e->v] && e->f > 0)
    {
      int d = SAP(e->v, std::min(delta-sum, e->f));
      e->f -= d;
      e->op->f += d;
      sum += d;
      if (dist[S] >= nodes || sum == delta)
        return sum;
    }
    if (e->f > 0)
      mindist = std::min(mindist, dist[e->v]);
  }
  if (sum == 0)
  {
    if (!--dc[dist[u]])
      dist[S] = nodes;
    else
      ++dc[dist[u] = mindist+1];
  }
  return sum;
}
std::vector<int> obj, exp;
void getsol(const int u)
{
  static bool vis[MAXN+MAXM+1];
  vis[u] = true;
  for (Edge *e = header[u]; e; e = e->next)
    if (e->f > 0 && !vis[e->v])
    {
      if (e->v < m)
        exp.push_back(e->v+1);
      else if (e->v != T)
        obj.push_back(e->v-m+1);
      getsol(e->v);
    }
}
int main()
{
  freopen("prog82.in", "r", stdin); 
  freopen("prog82.out", "w", stdout); 
  std::cin >> m >> n;
  S = m+n, T = S+1;
  int sum = 0;
  for (int i = 0; i < m; ++i)
  {
    std::string s;
    std::cin >> profit[i];
    std::getline(std::cin, s);
    add_edge(i, S, 0, add_edge(S, i, profit[i]));
    sum += profit[i];

    std::stringstream ss(s);
    for (int x; ss >> x; )
      add_edge(m+x-1, i, 0, add_edge(i, m+x-1, INF));
  }
  for (int i = 0, x; i < n; ++i)
  {
    std::cin >> x;
    add_edge(T, m+i, 0, add_edge(m+i, T, x));
  }

  int maxflow = 0;
  dc[0] = nodes = m+n+2;
  while (dist[S] < nodes)
    maxflow += SAP(S, INF);

  getsol(S);
  std::sort(exp.begin(), exp.end());
  std::copy(exp.begin(), exp.end(), std::ostream_iterator<int>(std::cout, " "));
  std::cout << std::endl;
  std::sort(obj.begin(), obj.end());
  std::copy(obj.begin(), obj.end(), std::ostream_iterator<int>(std::cout, " "));
  std::cout << std::endl << sum-maxflow;

  fclose(stdin);fclose(stdout); 
}
